/**
 * <copyright>
 * 
 * Copyright (c) 2021 Willink Transformations and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v2.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v20.html
 * 
 * Contributors:
 *   E.D.Willink - Initial API and implementation
 * 
 * </copyright>
 */
package org.eclipse.ocl.control;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Model</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * The ControlModel provides ResourceSet-specific settings to control OCL validation and show OCL diagnostics.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.ocl.control.ControlModel#getSettings <em>Settings</em>}</li>
 * </ul>
 *
 * @see org.eclipse.ocl.control.ControlPackage#getControlModel()
 * @model
 * @generated
 */
public interface ControlModel extends ControlElement {
	/**
	 * Returns the value of the '<em><b>Settings</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Settings</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Settings</em>' containment reference.
	 * @see #setSettings(ControlSettings)
	 * @see org.eclipse.ocl.control.ControlPackage#getControlModel_Settings()
	 * @model containment="true" required="true" ordered="false"
	 * @generated
	 */
	ControlSettings getSettings();

	/**
	 * Sets the value of the '{@link org.eclipse.ocl.control.ControlModel#getSettings <em>Settings</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Settings</em>' containment reference.
	 * @see #getSettings()
	 * @generated
	 */
	void setSettings(ControlSettings value);

} // ControlModel
